package sun.java2d;

import sun.java2d.d3d.D3DScreenUpdateManager;
import sun.java2d.windows.WindowsFlags;
import sun.awt.Win32GraphicsConfig;
import java.awt.Graphics2D;
import java.awt.Font;
import java.awt.Color;
import sun.awt.windows.WComponentPeer;

public class ScreenUpdateManager
{
    private static ScreenUpdateManager theInstance;
    
    protected ScreenUpdateManager() {
    }
    
    public synchronized Graphics2D createGraphics(SurfaceData surfaceData, WComponentPeer wComponentPeer, Color color, Color color2, Font font) {
        return new SunGraphics2D(surfaceData, color, color2, font);
    }
    
    public SurfaceData createScreenSurface(Win32GraphicsConfig win32GraphicsConfig, WComponentPeer wComponentPeer, int n, boolean b) {
        return win32GraphicsConfig.createSurfaceData(wComponentPeer, n);
    }
    
    public void dropScreenSurface(SurfaceData surfaceData) {
    }
    
    public SurfaceData getReplacementScreenSurface(WComponentPeer wComponentPeer, SurfaceData surfaceData) {
        SurfaceData surfaceData2 = wComponentPeer.getSurfaceData();
        if (surfaceData2 == null || surfaceData2.isValid()) {
            return surfaceData2;
        }
        wComponentPeer.replaceSurfaceData();
        return wComponentPeer.getSurfaceData();
    }
    
    public static synchronized ScreenUpdateManager getInstance() {
        if (ScreenUpdateManager.theInstance == null) {
            if (WindowsFlags.isD3DEnabled()) {
                ScreenUpdateManager.theInstance = new D3DScreenUpdateManager();
            }
            else {
                ScreenUpdateManager.theInstance = new ScreenUpdateManager();
            }
        }
        return ScreenUpdateManager.theInstance;
    }
}
